--- old/usr/src/uts/common/vm/seg_kpm.c	2015-11-24 09:35:11.070803959 -0500
+++ new/usr/src/uts/common/vm/seg_kpm.c	2015-11-24 09:35:11.074735333 -0500
@@ -103,10 +103,8 @@
 faultcode_t segkpm_fault(struct hat *hat, struct seg *seg, caddr_t addr,
 			size_t len, enum fault_type type, enum seg_rw rw);
 static void	segkpm_badop(void);
-static int	segkpm_notsup(void);
 
 #define	SEGKPM_BADOP(t)	(t(*)())segkpm_badop
-#define	SEGKPM_NOTSUP	(int(*)())segkpm_notsup
 
 static struct seg_ops segkpm_ops = {
 	.dup		= SEGKPM_BADOP(int),
@@ -126,7 +124,6 @@
 	.gettype	= SEGKPM_BADOP(int),
 	.getvp		= SEGKPM_BADOP(int),
 	.advise		= SEGKPM_BADOP(int),
-	.pagelock	= SEGKPM_NOTSUP,
 	.setpagesize	= SEGKPM_BADOP(int),
 	.getmemid	= SEGKPM_BADOP(int),
 	.getpolicy	= SEGKPM_BADOP(lgrp_mem_policy_info_t *),
@@ -310,9 +307,3 @@
 segkpm_badop() {}
 
 #endif	/* SEGKPM_SUPPORT */
-
-static int
-segkpm_notsup()
-{
-	return (ENOTSUP);
-}
--- old/usr/src/uts/common/vm/vm_seg.c	2015-11-24 09:35:11.189672179 -0500
+++ new/usr/src/uts/common/vm/vm_seg.c	2015-11-24 09:35:11.193656079 -0500
@@ -1974,6 +1974,9 @@
 segop_pagelock(struct seg *seg, caddr_t addr, size_t len, struct page ***page,
     enum lock_type type, enum seg_rw rw)
 {
+	if (seg->s_ops->pagelock == NULL)
+		return (ENOTSUP);
+
 	return (seg->s_ops->pagelock(seg, addr, len, page, type, rw));
 }
 
